/*
   Bernard Lidicky - 1999 (c)
	Star Shooter 2.10 - Full Screen
	
*/
#include <afxwin.h>
#include <time.h>
#include <winuser.h>
#include <ddraw.h>

#include "ddutil.h"

#include "defines.h"
#include "rc\resource.h"
#include "ufo.h"
#include "about.h"
#include "zivoty.h"
#include "nadpis.h"
#include "nova.h"


Aplikace A;

LPDIRECTDRAW            lpDD;           // DirectDraw object
LPDIRECTDRAWSURFACE     lpDDSPrimary;   // DirectDraw primary surface
LPDIRECTDRAWSURFACE     lpDDSBack;   // DirectDraw secondary surface
LPDIRECTDRAWSURFACE     lpDDSOne;   // surface s bitmapu plochy
LPDIRECTDRAWPALETTE     lpDDPal;  // paleta obrazku lpDDSOne

char szBitmap[] = "POZADI";
CBitmap *dd_pozadi;

HRESULT restoreAll( void )
{
    HRESULT	ddrval;

    ddrval = lpDDSPrimary->Restore();
    if( ddrval == DD_OK )
    {
	ddrval = lpDDSOne->Restore();
	if( ddrval == DD_OK )
	{
          DDReLoadBitmap(lpDDSOne, szBitmap);
	}
    }
    return ddrval;

} /* restoreAll */


BOOL Aplikace::InitInstance() {
		
	SetRegistryKey("Hippo Games");

	// zobrazeni okna
	m_pMainWnd = new Wokno;
	m_pMainWnd->ShowWindow(SW_SHOW);
 	m_pMainWnd->UpdateWindow();


	// zavedeni DirectX
   DDSURFACEDESC       ddsd;
   DDSCAPS             ddscaps;
   HRESULT             ddrval;

	// tvoreni objektu DX
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL ); // z lpDD je dd objekt
    if( ddrval != DD_OK ) return FALSE;

	 
	// Get exclusive mode - spojeni s objektem okna
	ddrval = lpDD->SetCooperativeLevel( m_pMainWnd->m_hWnd,  
				     DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN  );//| DDSCL_ALLOWREBOOT
    if( ddrval != DD_OK ) return FALSE;

	 // zmena rozliseni obrazovky
	 ddrval = lpDD->SetDisplayMode( 640, 480, 16 );  // zmena rozliseni
    if( ddrval != DD_OK ) return FALSE;

	// Create the primary surface with 1 back buffer - tvorba surfacu
	ddsd.dwSize = sizeof( ddsd );
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1; // pocet pouze pametovych obrazovek - na fillig
	ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
	if( ddrval != DD_OK ) return FALSE;

	// Get a pointer to the back buffer 
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
   ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, 
							  &lpDDSBack);

	
	if( ddrval != DD_OK ) return FALSE;
	
   // // create and set the palette
   lpDDPal = DDLoadPalette(lpDD, szBitmap);
   if (lpDDPal != NULL)
		ddrval = lpDDSPrimary->SetPalette(lpDDPal);

	// - pro rychlejsi kopirovani
   // Create the offscreen surface, by loading our bitmap.
 	lpDDSOne = DDLoadBitmap(lpDD, szBitmap, 0, 0);
	if ((lpDDSOne == NULL)) return FALSE;

	// tady nepouzito
//   DDSetColorKey(lpDDSOne, RGB(255,0,255)); // barva, ktera se bure pripadne ignorovat pri kopirovani bitmapp

	
	// zniceni ramecku okolo
	CRect Rect;
	SetRect(&Rect, 0, GetSystemMetrics(SM_CYCAPTION), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	AdjustWindowRectEx(&Rect, WS_POPUP | WS_CAPTION, FALSE, 0);
	m_pMainWnd->SetWindowPos(NULL, Rect.left, Rect.top, Rect.right-Rect.left, Rect.bottom-Rect.top, SWP_NOACTIVATE | SWP_NOZORDER);

	// init nove hry
	m_pMainWnd->PostMessage(WM_COMMAND,IDM_HRA_NOVA);


	return TRUE;

}

Aplikace::~Aplikace()
{
	delete m_pMainWnd;

   if( lpDD != NULL )
    {
	if( lpDDSPrimary != NULL )
	{
	    lpDDSPrimary->Release();
	    lpDDSPrimary = NULL;
	}
	if(lpDDSOne != NULL) 
		lpDDSOne->Release();
	if (lpDDPal != NULL)
		lpDDPal->Release();

	lpDD->Release();
	lpDD = NULL;
    }
}


BEGIN_MESSAGE_MAP(Wokno, CFrameWnd)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_MBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_WM_ACTIVATE()
	ON_WM_SETFOCUS()

	// menu
	ON_COMMAND(IDM_NAPIS_KONEC, _Konec)
	ON_COMMAND(IDM_HRA_NOVA, _Nova)
	ON_COMMAND(IDM_NAPOVEDA_OAPLIKACI, _About)
END_MESSAGE_MAP()

Wokno::Wokno() {
  
	
	srand( (unsigned)time( NULL ) );

	CRect rect;
	CString str = AfxGetApp()->GetProfileString("Vzhled", "pozice");
	if (!(str.IsEmpty())) rect.SetRect(atoi((const char*) str),atoi((const char*) str + 5),
												 atoi((const char*) str + 10),atoi((const char*) str + 15));
	else rect.SetRect(0,0,PLOCHAX,PLOCHAY);


// tvoreni okna
//	Create(NULL, "Star Shooter 2.00",WS_OVERLAPPEDWINDOW /*& (~(WS_MAXIMIZEBOX | WS_THICKFRAME))*/,rect,NULL,NULL);

	rect.bottom = 640;
	rect.left = 0;
	rect.right = 480;
	rect.top = 0;

	CreateEx(WS_EX_TOPMOST,NULL,"Star Shooter 2.00 - FullScreen",
			   WS_POPUP , rect, NULL, 0);


//	CenterWindow();

	GetClientRect(&Plocha);
	Plocha.right = 640;
	Plocha.bottom = 480;
	Plocha.left = 0;
	Plocha.top = 0;
// pridani menu
/*	CMenu menu;
	menu.LoadMenu(IDR_MENU);
	SetMenu(&menu);
	menu.Detach();
*/

// nastaveni ikonky
	HICON hIcon = AfxGetApp()->LoadIcon(IDI_ICON);
	SetIcon(hIcon, TRUE);
	SetIcon(hIcon, FALSE);

// init bitampy
	m_pPlocha = new CBitmap;
	m_pPlocha->LoadBitmap("POZADI");
	dd_pozadi = m_pPlocha;

    if( lpDDSOne == NULL )


	m_uTimerID = SetTimer(5,30,NULL);

	// urcuje zpusob hry - z registru
	if(AfxGetApp()->GetProfileInt("Hra","PL1",-1) == 1 ) PL1.automat = true;
	else PL1.automat = false;
	
	if(AfxGetApp()->GetProfileInt("Hra","PL2",-1) == 1 ) PL2.automat = true;
	else PL2.automat = false;
	
	CDC *dc = GetDC();
	PL1.Init(dc);
	PL2.Init(dc);

	ReleaseDC(dc);

	m_flip_active = false;
	diag_show = 1;
}

Wokno::~Wokno() {
	delete m_pPlocha;
	m_pPlocha = 0;
	
	// ulozeni dat do registru - pozice okna - nefunguje
	CString str;
	str.Format("%04d %04d %04d %04d",rect.left,rect.top,rect.right,rect.bottom);
	AfxGetApp()->WriteProfileString("Vzhled", "pozice",str);

	KillTimer(m_uTimerID);

}

void Wokno::OnPaint() {
/*
	if (m_flip_active) 
		if ( Redraw() ) return;
	
*/
	CDC cdc;
	CDC *dc_obrazovka = GetDC();
	CDC dc;

	CBitmap *swp;

	swp = new CBitmap;
	swp->CreateCompatibleBitmap(dc_obrazovka,640,480);

	dc.CreateCompatibleDC(dc_obrazovka);
	CBitmap *p_dc = dc.SelectObject(swp);

	// placnuti bitmapy
	cdc.CreateCompatibleDC(dc_obrazovka);
	CBitmap *pOB = cdc.SelectObject(m_pPlocha);
	dc.BitBlt (0,0,640,480,&cdc,0,0,SRCCOPY);
	cdc.SelectObject(pOB);
	
	// nejprve strely, pak rakety - aby strely neumazaval rakety
	PL1.Zobraz(m_pPlocha,Plocha,&dc);
	PL2.Zobraz(m_pPlocha,Plocha,&dc);
	m_meteor.Zobraz(m_pPlocha,Plocha,&dc);
	PL1.Zobraz_strely(m_pPlocha,Plocha,&dc);
	PL2.Zobraz_strely(m_pPlocha,Plocha,&dc);

	p_zivoty.Zobraz(&dc,rect,m_pPlocha,PL1.lives,PL2.lives);

	dc_obrazovka->BitBlt(0,0,640,480,&dc,0,0,SRCCOPY);
	
	ReleaseDC(dc_obrazovka);
	dc.SelectObject(p_dc);
	delete swp;

	CFrameWnd::OnPaint();
}

void Wokno::OnClose() {
	WINDOWPLACEMENT wpl;
	GetWindowPlacement(&wpl);
	rect = wpl.rcNormalPosition;

	PostMessage(WM_QUIT);
}

void Wokno::OnActivate(UINT nState, CWnd *pWndOther, BOOL bMinimized){
	// zniceni ramecku
	CRect Rect;
	SetRect(&Rect, 0, GetSystemMetrics(SM_CYCAPTION), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	AdjustWindowRectEx(&Rect, WS_POPUP | WS_CAPTION, FALSE, 0);
	SetWindowPos(NULL, Rect.left, Rect.top, Rect.right-Rect.left, Rect.bottom-Rect.top, SWP_NOACTIVATE | SWP_NOZORDER);

	CWnd::OnActivate(nState,pWndOther,bMinimized);
}

void Wokno::OnSetFocus(CWnd *pOldWnd){
	// zniceni ramecku
/*	CRect Rect;
	SetRect(&Rect, 0, GetSystemMetrics(SM_CYCAPTION), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	AdjustWindowRectEx(&Rect, WS_POPUP | WS_CAPTION, FALSE, 0);
   SetWindowPos(NULL, Rect.left, Rect.top, Rect.right-Rect.left, Rect.bottom-Rect.top, SWP_NOACTIVATE | SWP_NOZORDER);
*/

	CWnd::OnSetFocus(pOldWnd);
}


void Wokno::OnKillFocus( CWnd* pNewWnd ){

	SendMessage(WM_CLOSE);
	CWnd::OnKillFocus( pNewWnd );
}


void Wokno::_Konec() {
	SendMessage(WM_CLOSE,0,0);
}

void Wokno::_Nova() {
	 /* dialog nove hry*/
	
	if (m_uTimerID != 0) KillTimer(m_uTimerID);
	if (diag_show != 1) Redraw();
	PL1.Reset();
	PL2.Reset();
	PL1.killed = 0;
	PL2.killed = 0;
	CNova nova(this);
	nova.DoModal();

	m_uTimerID = SetTimer(5,30,NULL);

}

void Wokno::OnMouseMove(UINT nFlags, CPoint point) {
	if (PL1.automat == true) return;
	PL1.p_dest.x = long((PLOCHAX*point.x)/(Plocha.right));
	PL1.p_dest.y = long((PLOCHAY*point.y)/(Plocha.bottom));

	CWnd::OnMouseMove(nFlags, point);
}

void Wokno::OnTimer(UINT nIDEvent)
{
 	static int anim = 0;  // aktualni okenko animace
	int an = 0; // urcuje, ktera lod je vlevo / vpravo
	static int later = 0; // zpozduje animaci

	CWnd::OnTimer(nIDEvent);

	CDC *dc = GetDC();

	// Urceni smeru raket
	if (PL1.p_ufo.x < PL2.p_ufo.x) {
		an = 0;
		PL1.speed_shoot = SHOOT_SPEED;
		PL2.speed_shoot = -SHOOT_SPEED;
	}
	else {
		an = 1;
		PL1.speed_shoot = -SHOOT_SPEED;
		PL2.speed_shoot = SHOOT_SPEED;
	}


	if (++later > 100) later = 0;
	if (later%5 == 0) {
		if (++anim > 2) anim = 0; // zacikleni animace
		PL1.m_pUfo = PL1.m_animace[an][anim];
		PL1.m_pUfo_black = PL1.m_animace_black[an][anim];
		PL2.m_pUfo = PL2.m_animace[an][anim];
		PL2.m_pUfo_black = PL2.m_animace_black[an][anim];
	}

	// Animace raket pri malo zivotech
	if (PL1.lives <= 0) {
		if (PL1.lives >= -60) {
			PL1.m_pUfo = PL1.m_animace[an][abs(PL1.lives--)/6];
			PL1.m_pUfo_black = PL1.m_animace_black[an][abs(PL1.lives--)/6];
		}
		else 
			if ((++PL2.killed < KILLED)||(PL1.automat&&PL2.automat))PL1.Reset();
			else { // konec hry
				KillTimer(m_uTimerID);
				m_uTimerID = 0;
				if (diag_show != 1) Redraw();
				MessageBox("Je konec imperatora! \n Vudce povstalcu Zakhan se dostava do cela nove vlady a nici posledni zbytky privrzencu imperatora... ","End..");
				SendMessage(WM_COMMAND, IDM_HRA_NOVA);
			}
	}

	// druha raketa
	if (PL2.lives <= 0) {
		if (PL2.lives >= -60) {
			PL2.m_pUfo = PL2.m_animace[an][abs(PL2.lives--)/6];
			PL2.m_pUfo_black = PL2.m_animace_black[an][abs(PL2.lives--)/6];
		}
		else 
			if ((++PL1.killed < KILLED)||(PL1.automat&&PL2.automat)) PL2.Reset(); // demo do nekonecna
			else { // konec hry
				KillTimer(m_uTimerID);
				m_uTimerID = 0;
				if (diag_show != 1) Redraw();
				MessageBox("Jednotky povstalcu jsou porazeny! \n Pokracuje vlada imperatora Yarrdeshe I., ktery se tvrde msti ...","End..");
				SendMessage(WM_COMMAND, IDM_HRA_NOVA);
			}
	}


	p_zivoty.Test(&PL1, &PL2, &m_meteor);


	PL1.Move(PL2.p_ufo);
	PL2.Move(PL1.p_ufo);
	m_meteor.Move();

	// vlastni zobrazeni
   Redraw();

	ReleaseDC(dc);
	// Eat spurious WM_TIMER messages
	
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE));
	
}

void Wokno::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) {

	// Obluda 
	switch (nChar) {
		case VK_NUMPAD4:
		case VK_LEFT: 
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.kraj.left;
				PL2.p_dest.y = PL2.p_ufo.y;
			};
			break;
		case VK_NUMPAD6:
		case VK_RIGHT: 
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.kraj.right;
				PL2.p_dest.y = PL2.p_ufo.y;
			};
			break;
		case VK_NUMPAD8:
		case VK_UP: 
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.p_ufo.x;
				PL2.p_dest.y = PL2.kraj.top;
			};
			break;
		case VK_NUMPAD2:
		case VK_DOWN:
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.p_ufo.x;
				PL2.p_dest.y = PL2.kraj.bottom;
			};
			break;
		case VK_NUMPAD7:
		case VK_HOME:
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.kraj.left;
				PL2.p_dest.y = PL2.kraj.top;
			};
			break;
		case VK_NUMPAD9:
		/*case VK_PAGE_UP:*/
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.kraj.right;
				PL2.p_dest.y = PL2.kraj.top;
			};
			break;
		case VK_NUMPAD1:
		case VK_END:
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.kraj.left;
				PL2.p_dest.y = PL2.kraj.bottom;
			};
			break;
		case VK_NUMPAD3:
		/*case VK_PAGE_DOWN:*/
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.kraj.right;
				PL2.p_dest.y = PL2.kraj.bottom;
			};
			break;
		case VK_NUMPAD0:
		case VK_INSERT:
			if (PL2.automat != true){
				PL2.p_dest.x = PL2.p_ufo.x;
				PL2.p_dest.y = PL2.p_ufo.y;
			};
			break;
		case VK_SPACE : 
			if (PL2.automat != true){
			PL2.st_task = TASK_LR;
			};
			break;
		case 'C' : 
			if (PL2.automat != true){
				PL2.st_task = TASK_UP;
			};
			break;
		case 'X' :	
			if (PL2.automat != true){
				PL2.st_task = TASK_DN;
			};
			break;

		case VK_ESCAPE :
		case 'Q' :
			PostMessage(WM_CLOSE);
			break;

		case 'N' :
			_Nova();
			break;
		case 'A' :
			_About();
			break;
		case VK_RETURN : 
			PL1.st_task = TASK_UP;
			break;
		default:
			break;
	};

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void Wokno::OnLButtonDown(UINT nFlags, CPoint pint){
	if (PL1.automat == true) return;

	PL1.st_task = TASK_LR;
	
	CWnd::OnLButtonDown(nFlags,pint);
}

void Wokno::OnRButtonDown(UINT nFlags, CPoint pint){
	if (PL1.automat == true) return;

	PL1.st_task = TASK_DN;

	CWnd::OnRButtonDown(nFlags,pint);
}

void Wokno::OnMButtonDown(UINT nFlags, CPoint pint){
	if (PL1.automat == true) return;

	PL1.st_task = TASK_DN;
	
	CWnd::OnMButtonDown(nFlags,pint);
}


void Wokno::OnSize(UINT flag, int cx, int cy) {

	GetClientRect(&Plocha);
	Plocha.right -= Plocha.left;
	Plocha.bottom -= Plocha.top;

	CWnd::OnSize(flag,cx,cy);
}


int Nahoda(int nrOfSides)
{
	int testpoint;
	int r = rand();			// rand() vypot nhodn slo v rozsahu  a0x7FFF

	// konstanta RAND_MAX je definovna ve stdio.h na 0x07FFF
	int breakpoint = RAND_MAX / nrOfSides;  // rozdl RAND_MAX 
											//  na rovnomrn dly
	for (int c = 1; c < nrOfSides; c++) {	// Testuje kad rozsah
		testpoint = c * breakpoint;
		if (r < testpoint)
			break;		 // konec pi nalezen
	}	
	
	return (c - 1);	// vrt slo hodu
}

void Wokno::_About()
{
	if (m_uTimerID != 0) KillTimer(m_uTimerID);
	if (diag_show != 1) Redraw();

	CAbout dlg;
	dlg.DoModal();

   m_uTimerID = SetTimer(5,30,NULL);
}


bool Wokno::Redraw()
{
	
	CDC cdc;
	CDC *dc;
	HDC hDC;


	CRect rcRect;
	HRESULT ddrval;
   rcRect.left = 0;
   rcRect.top = 0;
   rcRect.right = 640;
   rcRect.bottom = 480;
   while( 1 )
   {
       ddrval = lpDDSBack->BltFast( 0, 0, lpDDSOne,
           &rcRect, DDBLTFAST_NOCOLORKEY );

	if( ddrval == DD_OK )
	{
	    break;
	}
	if( ddrval == DDERR_SURFACELOST )
	{
	    ddrval = restoreAll();
	    if( ddrval != DD_OK )
	    {
		break;
	    }
	}
	if( ddrval != DDERR_WASSTILLDRAWING )
	{
	    break;
	}
	 }

   if (lpDDSBack->GetDC(&hDC) == DD_OK)
	 dc = dc->FromHandle(hDC);
	else return false;

	if( ddrval != DD_OK )
	{

		cdc.CreateCompatibleDC(dc);
		CBitmap *pOB = cdc.SelectObject(m_pPlocha);
		::BitBlt(*dc,0,0,640,480,cdc,0,0,SRCCOPY);
		cdc.SelectObject(pOB);
		
	}
	 
	 
	 // nejprve strely, pak rakety - aby strely neumazaval rakety
	PL1.Zobraz(m_pPlocha,Plocha,dc);
	PL2.Zobraz(m_pPlocha,Plocha,dc);
	m_meteor.Zobraz(m_pPlocha,Plocha,dc);
	PL1.Zobraz_strely(m_pPlocha,Plocha,dc);
	PL2.Zobraz_strely(m_pPlocha,Plocha,dc);

	p_zivoty.Zobraz(dc,rect,m_pPlocha,PL1.lives,PL2.lives);

	lpDDSBack->ReleaseDC(dc->m_hDC);
	// uvolneni dc

	while( 1 )
	    {
		HRESULT ddrval;
		// prohozeni obrazovek
		ddrval = lpDDSPrimary->Flip( NULL, 0 );
		if( ddrval == DD_OK )  break;
		
		if( ddrval == DDERR_SURFACELOST ) {
		    ddrval = restoreAll();
		    if( ddrval != DD_OK )
			return false;
		}
		if( ddrval != DDERR_WASSTILLDRAWING ) break;
		}

	m_flip_active = true;
	
	diag_show = 0 - diag_show;

	return true;	
	
}
